<%@ page language="java" import="jfileupload.jspupload.*,java.util.*,java.io.*"%>
<%@ page errorPage="ExceptionHandler.jsp"%>
<%
	String directory = "c:/uploads";
	String tmpdirectory = "c:/uploads/tmp";
	boolean createsubfolders = true;
	boolean allowresume = true;
	boolean allowoverwrite = true;
	String encoding = "ISO-8859-1";
	boolean keepalive = false;
%>
<jsp:useBean id="upBean" scope="page" class="jfileupload.jspupload.FileUploadBean">
	<jsp:setProperty name="upBean" property="folderstore" value="<%=directory%>" />
	<jsp:setProperty name="upBean" property="parsertmpdir" value="<%=tmpdirectory%>" />
	<jsp:setProperty name="upBean" property="filesizelimit" value="8589934592" />
	<jsp:setProperty name="upBean" property="overwrite" value="<%=allowoverwrite%>" />
	<jsp:setProperty name="upBean" property="dump" value="true" />
</jsp:useBean>
<%!
	public long handle_put(jfileupload.jspupload.FileUploadBean bean, InputStream in, String file, String contentrange) throws Exception
	{
		long bytesWritten = 0L;
		Object tmpFout = null;
		String tmpFname = bean.getFolderstore() + java.io.File.separator + file;
		String tmpContentrange = contentrange;
		try
		{
			if (tmpContentrange != null)
			{
				// Resume upload.
				tmpContentrange = tmpContentrange.substring(6, tmpContentrange.length());
				tmpContentrange = tmpContentrange.substring(0, tmpContentrange.indexOf("-"));
				long skip = Long.parseLong(tmpContentrange);
				tmpFout = new RandomAccessFile(tmpFname, "rw");
				((RandomAccessFile) tmpFout).seek(skip);
			} 
			else tmpFout = new FileOutputStream(tmpFname);
			byte[] tmpBuffer = new byte[4096];
			int tmpRead = -1;
			while ((tmpRead = in.read(tmpBuffer)) != -1)
			{
				if (tmpFout instanceof RandomAccessFile) ((RandomAccessFile) tmpFout).write(tmpBuffer, 0, tmpRead);
				else ((FileOutputStream) tmpFout).write(tmpBuffer, 0, tmpRead);
				bytesWritten = bytesWritten + tmpRead;
			}
			if (tmpFout instanceof FileOutputStream) ((FileOutputStream) tmpFout).flush();
		}
		catch (Exception e)
		{
			throw e;
		}
		finally
		{
			if (tmpFout != null)
			{
				try
				{
					if (tmpFout instanceof RandomAccessFile) ((RandomAccessFile) tmpFout).close();
					else ((FileOutputStream) tmpFout).close();
				}
				catch (IOException ioe)
				{
					throw ioe;
				}
			}
			try
			{
				in.close();
			}
			catch (IOException io)
			{
				throw io;
			}		
		}
		return bytesWritten;
	}
%>
<%! 
	public String getSubFolder(String relative, String filename)
	{
		String subfolder = null;
		if ((filename != null) && (relative != null))
		{
			int inda = relative.length();
			int indb = filename.length();
			if (inda > indb)
			{
				subfolder = relative.substring(0, (inda - indb) - 1);
				subfolder = subfolder.replace('\\', '/').replace('/', java.io.File.separatorChar);
			}
		}
		return subfolder;
	}	
%>
<%
	//request.setCharacterEncoding(encoding);
	//response.setContentType("text/html; charset="+encoding);
	String method = request.getMethod();
	// Head processing to support resume and overwrite features.
	if (method.equalsIgnoreCase("head"))
	{
		String filename = request.getHeader("relativefilename");
		if (filename == null) filename = request.getHeader("filename");
		if (filename != null)
		{
			if (keepalive == false) response.setHeader("Connection", "close");
			String account = request.getHeader("account");
			if (account == null) account = "";
			else if (!account.startsWith("/")) account = "/" + account;
			File fhead = new File(directory + account + "/" + filename);
			if (fhead.exists())
			{
				response.setHeader("size", String.valueOf(fhead.length()));
				String checksum = request.getHeader("checksum");
				long checksumOffset = -1L;
				String checksumRange = request.getHeader("Range");
				if (checksumRange != null)
				{
				    int r = checksumRange.indexOf("-");
					if (r > 0)
					{
						checksumRange = checksumRange.substring(r+1, checksumRange.length());
						checksumOffset = Long.parseLong(checksumRange);
					}
				}
				if ((checksum != null) && (checksum.equalsIgnoreCase("crc")))
				{
					long crc = upBean.computeCRC32(fhead, checksumOffset);
					if (crc != -1) response.setHeader("checksum", String.valueOf(crc));
				} 
				else if ((checksum != null) && (checksum.equalsIgnoreCase("md5")))
				{
					String md5 = upBean.hexDump(upBean.computeMD5(fhead, checksumOffset)).toLowerCase();
					if ((md5 != null) && (!md5.equals(""))) response.setHeader("checksum", md5);
				}
			} 
			else response.sendError(HttpServletResponse.SC_NOT_FOUND);
			return;
		}
	}
%>
<%
	if (method.equalsIgnoreCase("put"))
	{
		String todo = request.getHeader("todo");
		if ((todo != null) && (todo.equalsIgnoreCase("upload")))
		{
			String account = request.getHeader("account");
			if (account == null) account = "";
			else if (!account.startsWith("/")) account = "/" + account;
			upBean.setFolderstore(directory + account);
			// Folders and subfolders creation support.
			String file = request.getHeader("filename");
			if (file == null) file = "filename.bin";
			String relative = request.getHeader("relativefilename");
			if ((createsubfolders == true) && (relative != null))
			{
				String subfolder = getSubFolder(relative, file);
				if (subfolder != null) upBean.setFolderstore(directory + account + java.io.File.separator + subfolder);
			}
			if (keepalive == false) response.setHeader("Connection", "close");		
			// Upload
			InputStream in = request.getInputStream();
			if (in != null)
			{
				String emptydirectory = request.getHeader("emptydirectory");
				if ((emptydirectory != null) && (!emptydirectory.equals("true")))
				{
					File dir = new File(directory + account + "/" + emptydirectory);
					dir.mkdirs();
				}
				else
				{
					long bytesWritten = handle_put(upBean, in, file, request.getHeader("Content-Range"));
					upBean.setFolderstore(directory + account);
				}
			}
		}
	}
%>
<html>
<head>
<title>Upload file: JSPScript sample</title>
<meta http-equiv="Content-Type"
	content="text/html; charset=<%=encoding%>">
</head>
<body>
<ul>
	<%
		if (MultipartFormDataRequest.isMultipartFormData(request))
		{
			// Parse multipart HTTP POST request.
			MultipartFormDataRequest mrequest = null;
			try
			{
				mrequest = new MultipartFormDataRequest(request, null, -1, MultipartFormDataRequest.CFUPARSER, encoding, allowresume);
			} 
			catch (Exception e)
			{
				// Cancel current upload (e.g. Stop transfer)
				// Only if allowresume = false
			}
			String todo = null;
			if (mrequest != null) todo = mrequest.getParameter("todo");
			if ((todo != null) && (todo.equalsIgnoreCase("upload")))
			{
				String account = mrequest.getParameter("account");
				if (account == null) account = "";
				else if (!account.startsWith("/")) account = "/" + account;
				upBean.setFolderstore(directory + account);
				Hashtable files = mrequest.getFiles();
				if ((files != null) && (!files.isEmpty()))
				{
					UploadFile file = (UploadFile) files.get("uploadfile");
					if (file != null) out.println("<li>Form field: uploadfile" + "<BR> Uploaded file: " + file.getFileName() + " (" + file.getFileSize() + " bytes)" + "<BR> Content Type: " + file.getContentType());
					// Folders and subfolders creation support.
					String relative = mrequest.getParameter("relativefilename");
					if ((createsubfolders == true) && (relative != null))
					{
						String subfolder = getSubFolder(relative, file.getFileName());
						if (subfolder != null) upBean.setFolderstore(directory + account + java.io.File.separator + subfolder);
					}
					if (keepalive == false) response.setHeader("Connection", "close");
					// Chunks recomposion support.
					String chunkidStr = mrequest.getParameter("chunkid");
					String chunkamountStr = mrequest.getParameter("chunkamount");
					String chunkbaseStr = mrequest.getParameter("chunkbase");
					if ((chunkidStr != null) && (chunkamountStr != null) && (chunkbaseStr != null))
					{
						// Always overwrite chunks.
						upBean.store(mrequest, "uploadfile");
						int chunkid = Integer.parseInt(chunkidStr);
						int chunkamount = Integer.parseInt(chunkamountStr);
						if (chunkid == chunkamount)
						{
							// recompose file.
							String fname = upBean.getFolderstore() + java.io.File.separator + chunkbaseStr;
							File fread = new File(fname);
							if (fread.canRead() && (upBean.getOverwrite() == false)) fname = fname + "." + System.currentTimeMillis();
							FileOutputStream fout = new FileOutputStream(fname);
							byte[] buffer = new byte[4096];
							for (int c = 1; c <= chunkamount; c++)
							{
								File filein = new File(upBean.getFolderstore() + java.io.File.separator + chunkbaseStr + "." + c);
								FileInputStream fin = new FileInputStream(filein);
								int read = -1;
								while ((read = fin.read(buffer)) > 0) fout.write(buffer, 0, read);
								fin.close();
								filein.delete();
							}
							fout.close();
						}
					} 
					else upBean.store(mrequest, "uploadfile");
					upBean.setFolderstore(directory + account);
				} 
				else
				{
					String emptydirectory = mrequest.getParameter("emptydirectory");
					if ((emptydirectory != null) && (!emptydirectory.equals("")))
					{
						File dir = new File(directory + account + "/" + emptydirectory);
						dir.mkdirs();
					}
					out.println("<li>No uploaded files");
				}
			} 
			else out.println("<BR> todo=" + todo);
		}
	%>
</ul>
<form method="post" action="process.jsp" name="upform" enctype="multipart/form-data"><br>
<table width="60%" border="0" cellspacing="1" cellpadding="1"
	align="center">
	<tr>
		<td align="left"><b>Select a file to upload:</b></td>
	</tr>
	<tr>
		<td align="left"><input type="hidden" name="todo" value="upload">
		<input type="file" name="uploadfile" size="50"></td>
	</tr>
	<tr>
		<td align="left"><input type="submit" name="Submit"
			value="Upload"> <input type="reset" name="Reset"
			value="Cancel"></td>
	</tr>
</table>
<p>&nbsp;</p>
<p>&nbsp;</p>
<p align="center">&nbsp;</p>
<p align="center">&nbsp;</p>
<p align="center"><font size="-1" face="Courier New, Courier, mono"><a href="http://www.jfileupload.com" target="_blank">JFileUpload</a></font></p>
</form>
</body>
</html>
